sub read_input {

$cgiurl = $ENV{'SCRIPT_NAME'};
$query=$ENV{'QUERY_STRING'};

$something_in=0;

if ($query) { @pairs=split(/&/,$query); }
else {
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	@pairs = split(/&/, $buffer);
}	
foreach $pair (@pairs) {
	$something_in=1;
	($name, $value) = split(/=/, $pair);
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$name =~ tr/+/ /;
	$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	if ($INPUT{$name}) { $INPUT{$name} = $INPUT{$name}.",".$value; }
	else { $INPUT{$name} = $value; }
}

}

###### VEFIY USER OR FORWARD TO LOGIN SCREEN ######
sub verify_user {
	
unless ($something_in) { &login; } ## SEND TO LOGIN SCREEN ##
if ($INPUT{'inital'}) { &inital_log; }
if ($INPUT{'logout'}) { &logout; }
&log; ## VERIFY USER AND COOKIE ##

}

###### SET NEW COOKIE ######
sub inital_log {

$account = $INPUT{'acc'};
$account = "\L$account\E"; ## LOWERCASE IT ##
@ch = split(//,$account);
$acc_dir = "$Config::path/accounts/$ch[0]/$account";

if (-e "$acc_dir/msg.txt") {
	open( MSG, "+<$acc_dir/msg.txt") || &error('open-write msg');
	if ($use_flock) {
		flock MSG, 2; 
	}
	@msg = <MSG>;

	## GENERATE RANDOM SESSION VARIABLE ##
	srand($time);
	$session ="";
	@passset = ('a'..'z', 'A'..'Z', '1'..'9');
	for ($i = 0; $i < 15; $i++) {
		$randum_num = int(rand($#passset + 1));
		$session .= @passset[$randum_num];
	}

	$onhold = $msg[7];
	chomp($onhold);
	if ($onhold) {
		close (MSG);
		&on_hold($onhold);
	}

	$msg[4] = "$time\n";
	$msg[5] = "$session\n";
	$msg[12] = "$INPUT{'frames'}\n";
	$msg[14] = $msg[13];
	$msg[13] = "$time\n";
	($msg[2],$msg[1]) = &space_used;
	$msg[2] .= "\n";
	$msg[1] .= "\n";
	seek (MSG, 0, 0);
	truncate (MSG,0);
	print MSG @msg;
	close (MSG);
}
else { &no_such_account($account); }

if (-e "$acc_dir/data.txt") {
	undef $/;
	open( MSG, "<$acc_dir/data.txt") || &error('open user info');
	$acc_data = <MSG>;
	close MSG;
	$/ = "\n";
	@acco = split(/\n/,$acc_data);
	unless ($INPUT{'password'} eq $acco[1]) { &pretty_error("Incorrect Account Password"); } 
}
else { &pretty_error("Fatal Account error, no data.txt file"); }
		
print "Set-Cookie: webbased=$account|$session|$time\;\n";
print "Content-type: text/html\n\n";

$Config::total_size = $Config::total_size + $msg[11];
&manage_temp_mime(0);

# Get Headers-Footers #
if ($msg[9] == 1) {
	$HTML::menu_top = "menu_top_no.txt";
	$HTML::menu_bot = "menu_bot_no.txt";
	$HTML::main_top = "menu_mtop_no.txt"; 
	$HTML::main_bot = "menu_mbot_no.txt";
	$HTML::splash_html = "menu_splash_no.txt";
	$HTML::tag = "tag_no.txt";
}
elsif ($msg[9] == 2) {
	$HTML::menu_top = "/dev/null";
	$HTML::menu_bot = "/dev/null";
	$HTML::main_top = "/dev/null"; 
	$HTML::main_bot = "/dev/null";
	$HTML::splash_html = "/dev/null";
	$HTML::tag = "/dev/null";
}

else {
	$HTML::menu_top = "menu_top_ad.txt";
	$HTML::menu_bot = "menu_bot_ad.txt";
	$HTML::main_top = "menu_mtop_ad.txt"; 
	$HTML::main_bot = "menu_mbot_ad.txt";
	$HTML::splash_html = "menu_splash_ad.txt";
	$HTML::tag = "tag_ad.txt";
}


if ($INPUT{'frames'}) { 
	$frames_on=1; 
	&print_frame;
}
if ($Config::splash) { &splash_screen; }
else { &folder("inbox"); }
exit;
}

###### VERIFY USER AND COOKIE -- SET NEW COOKIE ######
sub log {

$account = $INPUT{'acc'};
$account = "\L$account\E"; ## LOWERCASE IT ##
@ch = split(//,$account);
$acc_dir = "$Config::path/accounts/$ch[0]/$account";

if ($ENV{'HTTP_COOKIE'}) {
	$the_cook =$ENV{'HTTP_COOKIE'};
	@cook_parts = split(/\;/,$the_cook);
	foreach $part(@cook_parts) {
		$part =~ s/^ //;
		if ($part =~ /^webbased/) {
			$the_cook = $part;
			$the_cook =~ s/.*?=//;
		}
	}
	@cook = split(/\|/,$the_cook);
	$cook_account = $cook[0];
	$cook_rand = $cook[1];
	$log_time = $cook[2];
	$ses_len = $time - $log_time;
	
	if ($cook_account ne $account) { &pretty_error("Account listed in cookie and one provided are different"); }
	if ($ses_len > 1800) { &pretty_error("Session has expired, please log in again"); }
}
else {
	&pretty_error("Session has expired, please log in again"); 
}

if (-e "$acc_dir/msg.txt") {
	open( MSG, "+<$acc_dir/msg.txt") || &error('open-write msg');
	if ($use_flock) {
		flock MSG, 2; 
	}
	@msg = <MSG>;
	
	chomp($msg[4]);
	chomp($msg[5]);
	$ltime = $time - $msg[4];	
	
	if ($ltime > 1800) { &pretty_error("Session has expired, please log in again."); }
	if ($msg[5] ne $cook_rand) { &pretty_error("Invalid session, please log in again"); }

	$msg[4] = "$time\n";
	$msg[5] .= "\n";
	
	($msg[2],$msg[1]) = &space_used;
	$msg[2] .= "\n";
	$msg[1] .= "\n";
	
	seek (MSG, 0, 0);
	truncate (MSG,0);
	print MSG @msg;
	close (MSG);
}
else { &pretty_error("Fatal Account error, no msg.txt file"); }

if (-e "$acc_dir/data.txt") {
	undef $/;
	open( MSG, "<$acc_dir/data.txt") || &error('open user info');
	$acc_data = <MSG>;
	close MSG;
	$/ = "\n";
	@acco = split(/\n/,$acc_data);
}
else { &pretty_error("Fatal Account error, no data.txt file"); }

# Get Headers-Footers #
if ($msg[9] == 1) {
	$HTML::menu_top = "menu_top_no.txt";
	$HTML::menu_bot = "menu_bot_no.txt";
	$HTML::main_top = "menu_mtop_no.txt"; 
	$HTML::main_bot = "menu_mbot_no.txt";
	$HTML::splash_html = "menu_splash_no.txt";
	$HTML::tag = "tag_no.txt";
}
elsif ($msg[9] == 2) {
	$HTML::menu_top = "/dev/null";
	$HTML::menu_bot = "/dev/null";
	$HTML::main_top = "/dev/null"; 
	$HTML::main_bot = "/dev/null";
	$HTML::splash_html = "/dev/null";
	$HTML::tag = "/dev/null";
}

else {
	$HTML::menu_top = "menu_top_ad.txt";
	$HTML::menu_bot = "menu_bot_ad.txt";
	$HTML::main_top = "menu_mtop_ad.txt"; 
	$HTML::main_bot = "menu_mbot_ad.txt";
	$HTML::splash_html = "menu_splash_ad.txt";
	$HTML::tag = "tag_ad.txt";
}



$frames_on = $msg[12];
chomp($frames_on);

		
print "Set-Cookie: webbased=$account|$cook_rand|$time\;\n";
print "Content-type: text/html\n\n";

&manage_temp_mime(0);
$Config::total_size = $Config::total_size + $msg[11];
}

####### LOG OUT ##########
sub logout {
	
$account = $INPUT{'acc'};
@ch = split(//,$account);
$acc_dir = "$Config::path/accounts/$ch[0]/$account";	
	
print "Set-Cookie: webbased=\;\n";
print "Content-type: text/html\n\n";

&manage_temp_mime(1);

print "<HTML><HEAD><TITLE>Come back again soon</TITLE></HEAD><BODY>\n";
print "<font face=arial size=-1><B>You have been logged out........</B></FONT><BR><BR>";
if (-e "$Config::path/html/logout.txt") {
	open (HEAD, "$Config::path/html/logout.txt");
	@lout = <HEAD>;
	close (HEAD);
print @lout;
}
print "</BODY></HTML>\n";


exit;
}

###### PRINT MAIN LOGIN SCREEN #####
sub login {
print "Content-type: text/html\n\n";
print "<HTML><HEAD><TITLE>$Config::name</TITLE></HEAD><BODY>\n";
print <<EOF;
<form action="read.cgi" method="POST">
<TABLE CELLPADDING=6 CELLSPACING=0 BORDER=1 align=center>
<TR><TD>
<TABLE CELLPADDING=6 BORDER=0 align=center>
<TR><TD>
<font face=arial size=-1>Username:
</TD><TD>
<input type="Text" name="acc" size="15">
</TD></TR>
<TR><TD>
<font face=arial size=-1>Password:
</TD><TD>
<input type="PASSWORD" name="password" size="15">
</TD></TR>
<TR><TD COLSPAN=2><FONT FACE=arial size=-2>
<input type="radio" name="frames" value="0"> No Frames<BR>
<input type="radio" name="frames" value="1" SELECTED> Use Frames<BR>
</TD></TR>
<TR><TD COLSPAN=2 ALIGN=CENTER>
<input type="Submit" name="inital" value="  login  ">
</TD></TR></TABLE></TD></TR></TABLE>
</form>
EOF
exit;
}

########## FIND SPACE USED ##########
sub space_used {
	

opendir (DIR, "$acc_dir") || &error("can not open $acc_dir");
@dirs = grep {!(/^\./) && -d "$acc_dir/$_"}  readdir(DIR);
close (DIR); 
$curr_num=0;
$curr_size=0;
foreach $ddir(@dirs) {
	opendir (DIR, "$acc_dir/$ddir") || &error("can not open $acc_dir/$ddir");
	@files = grep {!(/^\./) && -f "$acc_dir/$ddir/$_"}  readdir(DIR);
	close (DIR); 	
	$num = push(@files);
	foreach $file(@files) {
		$curr_num++;
		@stats = stat("$acc_dir/$ddir/$file");
		$size = $stats[7];
		$size = $size /1024;
		$curr_size = $size + $total_ks;
		
		undef $/;
		open (HEAD, "$acc_dir/$ddir/$file") || &error("reading $acc_dir/$ddir/$file");	
		$email = <HEAD>;
		close (HEAD);
		$/="\n";
		
		$email =~ /^GotTime:\s*(.*)/mi;
		$real_date = $1;
		chomp($real_date);
		$last_new = $msg[14];
		chomp($last_new);
		if ($ddir ne "sent") {
			if ($real_date > $last_new) { $new_emails++; }
		}
	}
}
return($curr_size,$curr_num);
}
########## DELETE ALL/OLD ATTACHMENTS ##########
sub manage_temp_mime {

$delete_all = $_[0];

opendir(DIR,"$Config::mime_path/$account");
@dirs = grep {!(/^\./) && -d "$Config::mime_path/$account/$_" } readdir(DIR);
close DIR;

foreach $dir(@dirs) {

	opendir (DIR, "$Config::mime_path/$account/$dir");
	@files = grep {!(/^\./) && -f "$Config::mime_path/$account/$dir/$_"}  readdir(DIR);
	close (DIR); 

	foreach $file(@files) {
		@stats = stat("$Config::mime_path/$account/$dir/$file");
		$mtime = $stats[9];
		$mmtime = $time - $mtime;
		if (($mmtime > 1800) || $delete_all) {
			unlink("$Config::mime_path/$account/$dir/$file") || &error("unlinking $file");
		}
	}
	rmdir("$Config::mime_path/$account/$dir");	
}
unlink("$Config::mime_path/$account/index.html");
rmdir("$Config::mime_path/$account");

}

########## PRINT FRAMES ##########
sub print_frame {

print <<EOF;
<HTML>
<HEAD>
	<TITLE>$Config::name</TITLE>
</HEAD>
<FRAMESET ROWS="100%" COLS="155,*" border=0 >
	<FRAME NAME="LEFT" SRC="read.cgi?acc=$account&action=menu"  FRAMEBORDER=0 frameborder="NO" border=0 MARGINHEIGHT=5 MARGINWIDTH=5 framespacing=0>
	<FRAME NAME="main" SRC="read.cgi?acc=$account&action=main" FRAMEBORDER=0 frameborder="NO" border=0 MARGINHEIGHT=5 MARGINWIDTH=5 framespacing=0>
</FRAMESET>
<NOFRAMES>
Please use unframed version.....
<BR><BR>
EOF
&login;
print <<EOF;
</BODY>
</NOFRAMES>
</HTML>
EOF
}


########## HEADER ##########
sub Header {
	

@mahead='';

if ((-e "$Config::path/html/$HTML::main_top") && $HTML::main_top) {
	open (HEAD, "$Config::path/html/$HTML::main_top");
	@mahead = <HEAD>;
	close (HEAD);	
}


print <<EOF;
<HTML><HEAD><TITLE>Alias-Mail Demo</TITLE></HEAD>
<BODY vlink=blue alink=blue bgcolor=white>
EOF

unless ($frames_on) {
	print "<TABLE border=0 cellpadding=6 cellspacing=0 width=750>\n";
	print "<TR><TD width=135 valign=top bgcolor=\#336699>\n";
	&header_links;
	print "</TD><TD valign=top align=center width=615>\n";
}
print "@mahead\n<CENTER>\n";

}

############ FRAME MENU ##########
sub header_menu {
	
print "<HTML><HEAD><TITLE>Alias-Mail Demo</TITLE></HEAD>\n";
print "<BODY vlink=blue alink=blue bgcolor=\#336699>\n";
&header_links;
print "</BODY></HTML>";
exit;
}
########## FRAME MAIN ##########
sub header_main {

if ($Config::splash) { &splash_screen; }
else { &folder("inbox"); }
exit;


}
########## HEADER LINKS ##########
sub header_links {

@mehead='';
@mefoot='';
if ((-e "$Config::path/html/$HTML::menu_top") && $HTML::menu_top) {
	open (HEAD, "$Config::path/html/$HTML::menu_top");
	@mehead = <HEAD>;
	close (HEAD);	
}
if ((-e "$Config::path/html/$HTML::menu_bot") && $HTML::menu_bot) {
	open (HEAD, "$Config::path/html/$HTML::menu_bot");
	@mefoot = <HEAD>;
	close (HEAD);	
}


$frames_target="";
if ($frames_on) { $frames_target="target=\"main\""; }

print <<EOF;

@mehead
<BR>
<font face=arial size=-1>
<A HREF="read.cgi?acc=$account&folder=inbox" $frames_target><font color=white>Inbox <SMALL>(Check Mail)</SMALL></FONT></A><BR>
<A HREF="read.cgi?acc=$account&write=newmsg" $frames_target><font color=white>Compose</FONT></A><BR>
<A HREF="address_book.cgi?acc=$account&action=show" $frames_target><font color=white>Address Book</FONT></A><BR>
<A HREF="user_pref.cgi?acc=$account&action=sigs" $frames_target><font color=white>Signatures</FONT></A><BR>
<A HREF="user_pref.cgi?acc=$account&action=show" $frames_target><font color=white>Preferences</FONT></A><BR>
<A HREF="read.cgi?acc=$account&action=folders" $frames_target><font color=white>Folders</FONT></A><BR>
<A HREF="read.cgi?acc=$account&folder=sent" $frames_target><font color=white>Sent Items</FONT></A><BR>
<A HREF="read.cgi?acc=$account&folder=trash" $frames_target><font color=white>Trash</FONT></A><BR>
<BR>
EOF
chomp($msg[15]);
if ($Config::pop3 || $msg[15]) {
print <<EOF;
<A HREF="user_pref.cgi?acc=$account&action=pop" $frames_target><font color=white>Check external mail</FONT></A><BR>
EOF
}
print <<EOF;
<A HREF="help.cgi" $frames_target><font color=white>Help</FONT></A><BR>
<A HREF="read.cgi?acc=$account&logout=come+again+soon" target="_top"><font color=white>Log Out</FONT></A><BR>
@mefoot
<CENTER><BR><BR>
<HR noshade size=1 width=100%>
<font color=white face=arial size=-1>
<A HREF="http://alias-mail.com" target="_TOP"><FONT COLOR=WHITE>Alias-Mail</FONT></A><BR></FONT>
<font color=white face=arial size=-2>
From <A HREF="http://solutionscripts.com" target="_TOP"><FONT COLOR=WHITE>Solution Scripts</FONT></A>
EOF
}



######### FOOTER #########
sub Footer {

if ((-e "$Config::path/html/$HTML::main_bot") && $HTML::main_bot) {
	open (HEAD, "$Config::path/html/$HTML::main_bot");
	@mafoot = <HEAD>;
	close (HEAD);	
}

print "@mafoot\n";
unless ($frames_on) {
	print "</TD></TR></TABLE>\n";
}
print "</BODY></HTML>\n";
}

########## FATAL ERROR MESSAGES ##########
sub error {
unless($ct) { print "Content-type: text/html\n\n"; $ct=1; }
print "$_[0] -- $!";
exit;
}

########## SESSION - COOKIE ERROR MESSAGES ##########
sub pretty_error {
unless($ct) { print "Content-type: text/html\n\n"; $ct=1; }
print <<EOF;
<HTML><HEAD><TITLE>An Error has occured</TITLE></HEAD>
<BODY bgcolor=white link=blue vlink=blue>
<TABLE BORDER=1 cellpadding=15 cellspacing=0 align=center>
<TR><TD align=center><font face=arial>
<font color=red><B>
$_[0]<B></FONT>
</TD></TR></TABLE>
<BR><BR>
<TABLE border=0 width=550 align=center>
<TR><TD>
<font face=arial size=-1>
For one reason or another an error has occured and you must 
<A HREF="read.cgi">login in again</A>.
<BR><BR>
For security reasons, $Config::name only allows you 30 minutes of inactivity.
If you have not done anything with in your account in the last thirty minutes you session will automatically
expire, thus causing this screen to appear. 
<BR><BR>
If you receive error relating to username does not match or session id does not match, 
this means you cookie is either invalid or out of date. You should login again to reset
your cookie settings.
<BR><BR>
$Config::name requires cookies to be used to authorize you while you are managing your email account.
These cookies can be erased from your computer from clicking the <B>Log out</B> button from the left hand menu.
Once this is done no further actions can be taken in your account until you login in again.
No sensative data is stored in the cookie. Only your account name, a session string and the current time. Your password is not stored 
in the cookie nor displayed in any hidden forms on the web site.
<BR>
<BR>
Should you have any other questions about $Config::name, please visit our 
<A HREF="help.cgi">Help Section</A>. Thank you...
</TD></TR></TABLE>
</BODY></HTML>
EOF
exit;
}

sub no_such_account {

unless($ct) { print "Content-type: text/html\n\n"; $ct=1; }
print <<EOF;
<HTML><HEAD><TITLE>An Error has occured</TITLE></HEAD>
<BODY bgcolor=white link=blue vlink=blue>
<TABLE BORDER=1 cellpadding=15 cellspacing=0 align=center>
<TR><TD align=center><font face=arial>
No account under the username <font color=red>$_[0]</FONT>
was found.<BR><BR>
Please check the speling and try again
</TD></TR></TABLE>
</BODY></HTML>
EOF
exit;
}

sub on_hold {

unless($ct) { print "Content-type: text/html\n\n"; $ct=1; }
print <<EOF;
<HTML><HEAD><TITLE>$Config::name</TITLE></HEAD>
<BODY bgcolor=white link=blue vlink=blue>
<TABLE BORDER=1 cellpadding=15 cellspacing=0 align=center>
<TR><TD align=center><font face=arial>
This account is currently onhold and can not be accessed.
<BR><BR>
<font color=red>
$_[0]</FONT><BR><BR>
</TD></TR></TABLE>
<BR><BR>
EOF
exit;
}
1;
